#!/bin/sh

if [ $# -ne 2 ]; then
    echo "Usage: $0 <bin file> <symbol name>"
    exit 1
fi

FUNC_ADDR=$(rabin2 -s $1 | grep "name=$2$" | sed -r 's/^.*address=(\w*).*$/\1/')
FUNC_OFF=$(rabin2 -s $1 | grep "name=$2$" | sed -r 's/^.*offset=(\w*).*$/\1/')
PUTS_ADDR=$(rabin2 -i $1 | grep puts | sed -r 's/^.*address=(\w*).*$/\1/')

echo "Binary Injection (Demo 1)"
echo "-------------------------"
echo "$2 address: ${FUNC_ADDR}"
echo "$2 offset:  ${FUNC_OFF}"
echo "puts address:        ${PUTS_ADDR}"
echo "-------------------------"
echo "Injecting code into $1 @ ${FUNC_OFF}"
echo "puts(\"Hello world\");"
echo "-------------------------"
echo " \
	s ${FUNC_OFF} && \
	wx $(rasm2 -b 64 -o ${FUNC_ADDR} \
		"push rbp
		mov rbp, rsp
		mov rdi, _hello
		call ${PUTS_ADDR}
		mov eax, 0x0
		pop rbp
		ret
		_hello:.string Hello world")
" | radare2 -w $1 > /dev/null
echo "Done"
